contextMenuBackground.showImageContextMenu();
contextMenuBackground.showInputContextMenu();
contextMenuBackground.showImageAutosearchContextMenu();
chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.type == "setCaptchaDeterminer") {
        delete request.type;
        var domain;
        if (request.domain) {
            domain = request.domain
        } else {
            domain = parseUrl(sender.url).hostname;
            request.domain = domain
        }
        setCaptchaDomainDeterminant(domain, request, function() {
            (chrome.storage.sync && typeof browser == "undefined" ? chrome.storage.sync : chrome.storage.local).get(function(data) {
                sendResponse(typeof data.captchaDeterminant !== "undefined" ? data.captchaDeterminant : null)
            })
        })
    } else if (request.type == "getCaptchaDeterminer") {
        delete request.type;
        var domain = parseUrl(sender.url).hostname;
        request.domain = domain;
        getCaptchaDomainDeterminant(domain, function(captchaDeterminant) {
            if (captchaDeterminant) {
                if (typeof captchaDeterminant.source == "undefined") {
                    captchaDeterminant.source = "manual"
                }
                sendResponse(captchaDeterminant)
            } else if (globalStatus.use_predefined_image_captcha_marks && typeof predefinedHostnameSelectors[domain] != "undefined") {
                predefinedHostnameSelectors[domain].source = "predefined";
                sendResponse(predefinedHostnameSelectors[domain])
            } else {}
            sendResponse(captchaDeterminant)
        });
        eventualPredefinedHostnameSelectorsInit();
        eventualPluginLastVersionCheck()
    } else if (request.type == "requestPermissions") {
        delete request.type;
        chrome.permissions.request({
            permissions: request.permissions
        }, sendResponse);
        return true
    } else if (request.type == "setImageCaptchaCache") {
        delete request.type;
        ImageCaptchaCache.set(request.index, request.value)
    } else if (request.type == "getImageCaptchaCache") {
        delete request.type;
        sendResponse(ImageCaptchaCache.get(request.index))
    }
    return true
});